#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>
#include <queue>
#include <map>
#include <set>

#ifdef WIN32
    #define I64 "%I64d"
#else
    #define I64 "%lld"
#endif // WIN32

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 2002
#define md 1000000007
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define EPS 0.00000001
#define ll long long
#define ull unsigned long long

using namespace std;
int n, t, m;
vector<vector<int> > a;


int BFS(int x) {
    vector<pair<int, int> > q;
    vector<bool> f;
    f = vector<bool> (n + 1, false);
    int beg = 0;
    q.push_back(make_pair(x, 0));
    while (beg < q.size()) {
        int cur = q[beg].first;
        for (int j = 0; j < a[j].size(); j++) {
            if (f[a[cur][j]] == true) {
                return q[beg].second + 1;
            } else {
                q.push_back(make_pair(a[cur][j], q[beg].second + 1));
            }
        }
        beg++;
    }
    return md;
}

int BruteForce() {
    int ans = md;
    for (int i = 1; i <= n; i++) {
        ans = min(BFS(i), i);
    }
}

int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG
    cin >> t;
    for (int i = 0; i < t; i++) {
        cin >> n >> m;
        vector<int> temp;
        a.clear();
        a = vector<vector<int> > (n + 1, temp);
        for (int j = 0 ; j < m; j++) {
            int x, y;
            cin >> x >> y;
            a[x].push_back(y);
            a[y].push_back(x);
        }
        cout << BruteForce();
    }

    return 0;
}
