#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e5+11;
const int inf = int(1e9);
const int mod = inf;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n, m;
ll a[maxn], b[maxn];
ll d[maxn];
int k, s;

ll calc(int x){
	ll &res = d[x];
	if ( res != -1 ) return res;
	res = 0;
	for (int i=0;i<k;i++){
		if ( x + a[i] < m ){
			res += calc(x+a[i]);
			res %= mod;
		}
	}
	for (int i=0;i<s;i++){
		if ( x*1ll*b[i] < m){
			res += calc(x*b[i]);
			res %= mod;
		}
		if(x * 1ll * b[i] == m) res = (res + 1) % mod;
	}
	return res;
}
 	
void Solve(){
	scanf("%d%d", &n, &m);
	scanf("%d", &k);
	for (int i=0;i<k;i++) scanf("%d", &a[i]);

	sort(a, a + k);
	k = unique (a, a + k ) - a;

	scanf("%d", &s);
	for (int i=0;i<s;i++) scanf("%d", &b[i]);

	sort(b, b + s);
	s = unique (b, b + s) - b;

	memset(d, -1, sizeof(d));
	cout <<calc(n)<<endl;
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	int t;
	scanf("%d", &t);
	for (int i=0;i<t;i++){
		Solve();
	}	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
