#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e3+11;
const int inf = int(1e9);
const int mod = 2017;
const double eps = 1e-9;
const double pi = acos(-1.0);

bool check(int n) {
	for(int i = 2; i < n; i++)
		if(n % i == 0) return false;
	return true;
}

int n, k;

int binpow(int a, int k) {
	if(k == 0) return 1;
	int ans = binpow(a, k / 2);
	ans = 1ll * ans * ans % mod;
	if(k % 2) ans = 1ll * ans * a % mod;
	return ans;
}

void solve() {
	cin >> n >> k;

	int up = 1;
	int down = 1;

	if(k == 1) {
		cout << 1 << endl;
		return;
	}

	for(int i = 0; i < k-1; i++) up = 1ll * up * (n + i) % mod;
	for(int i = 1; i < k; i++) down = down * 1ll * i % mod;
	down = 1ll * down * k % mod;
	up = 1ll * up * (n-1) % mod;

	down = binpow(down, mod-2);

	int ans = up * 1ll * down % mod;

	cout << ans << endl;
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	int t;

	cin >> t;

	while(t--) {
		solve();
	}

	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
