#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
typedef vector<int> VI;
#define fname ""
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()

const int maxn = (int)1e6;
const LL inf = (1ll << 40) - 1;

LL gcd(LL a, LL b, LL &x, LL &y)
{
	if (a == 0) {
		x = 0, y = 1;
		return b;
	}
	LL x0, y0, g;
	g = gcd(b % a, a, x0, y0);
	x = y0 - b/a * x0;
	y = x0;
	return g;
}


LL A, B, x, y, t, n, d[1005][1005], g;
pair <LL, LL> ans;

int main()
{
//	freopen(fname"in", "r", stdin);
//	freopen(fname"out", "w", stdout);

	cin >> t;
	while (t--)
	{
		ans = mp(inf, inf);
		cin >> n;
		d[1][0] = 1;
		d[2][1] = 1;
		for (int i = 3; i <= 100; i++)
		{
			d[i][0] = d[i - 1][0] + d[i - 2][0];
			d[i][1] = d[i - 1][1] + d[i - 2][1];
			if (d[i][0] + d[i][1] > n)
				break;
			A = d[i][0];
			B = d[i][1];

			g = gcd(A, B, x, y);
			if (n % g != 0)
				continue;
			n /= g;
			A /= g;
			B /= g;
		//	cerr << A * x << '+' << B * y << '=' << n << '\n';
			x = x * n;
			y = y * n;
			if (x < y) { 
				LL k = (y - x) / (A + B);
				x += k * B;
				y -= k * A;
			}
			if (x > y) {
				LL k = (x - y + A + B - 1) / (A + B);
				x -= k * B;
				y += k * A;
			}
		//	cerr << i << ' ' << x * A << '+' << y * B << ' ' << n << '\n';
			if (x > 0 && y > 0) 
				ans = min(ans, mp(y, x));
		}
		cout << ans.S << " " << ans.F << "\n";
	}
	return 0;
}
