#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;
const int mod = (int)1e9;
const int K = 200;

int a[K], b[K];
int dp[N];

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	int t;
	scanf("%d", &t);
	while (t--) {
		int n, m;
		scanf("%d %d", &n, &m);
		int k, s;
		scanf("%d", &k);
		for (int i = 0; i < k; i++)
			scanf("%d", a + i);
		sort(a, a + k);
		k = unique(a, a + k) - a;
		scanf("%d", &s);
		for (int i = 0; i < s; i++)
			scanf("%d", b + i);
		sort(b, b + s);
		s = unique(b, b + s) - b;
		dp[n] = 1;
		for (int i = n+1; i < (m+1)/2; i++) {
			dp[i] = 0;
			for (int j = 0; j < k; j++) {
				int p = i - a[j];
				if (p < n) break;
				dp[i] += dp[p];
				if (dp[i] >= mod) dp[i] -= mod;
			}
			for (int j = 0; j < s; j++) {
				int p = i / b[j];
				if (p < n) break;
				if (i % b[j] == 0) {
					dp[i] += dp[p];
					if (dp[i] >= mod) dp[i] -= mod;
				}
			}
		}
		dp[m] = 0;
		for (int j = 0; j < s; j++) {
			int p = m / b[j];
			if (p < n) break;
			if (m % b[j] == 0) {
				dp[m] += dp[p];
				if (dp[m] >= mod) dp[m] -= mod;
			}
		}
		printf("%d\n", dp[m]);
	}

	return 0;
}
