#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

bool rec(ll i, ll n, map < ll, bool > & d) {
	if(i >= n)
		return false;
	if(d.count(i) > 0)
		return d[i];
	bool loseFound = false;
	for(ll j = 2; j <= 9; j++) {
		if(!rec(i * j, n, d)) {
			loseFound = true;
			break;
		}
	}
	d[i] = loseFound;
	//cout << i << " " << loseFound << endl;
	return loseFound;
}

int main() {
	ios_base::sync_with_stdio(false);
	int tests;
	cin >> tests;
	for(int test = 0; test < tests; test++) {
		ll n;
		cin >> n;
		map < ll, bool > states;
		rec(1, n, states);
		bool result = states[1];
		cout << (result ? 1 : 2) << "\n";
	}
	return 0;
}