#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	for (int i = 1; i <= t; ++i) {
		cout << "Test " << i << "\n";
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


#define int li

vector <char> get(int x) {
	vector <char> res;
	if (x == 0) {
		res.push_back('0');
		return res;
	}

	while (x) {
		res.push_back((x & 1LL) + '0');
		x /= 2LL;
	}
	return res;
}

int read() {
	string s;
	cin >> s;
	int res = 0;
	for (int i = 0; i < s.size(); ++i) {
		res = res * 2LL + (s[i] - '0');
	}
	return res;
}

void solve() {
	int a[3];
	a[0] = read();
	a[1] = read();

	a[2] = a[0] * a[1];

	vector <vector <char > > res;

	vector <char> b[3];

	for (int i = 0; i < 3; ++i) {
		b[i] = get(a[i]);
	}

	if (a[2] == 0) {
		while (b[2].size() < max(b[0].size(), b[1].size())) {
			b[2].push_back(' ');
		}
	}
	res.resize(2 + 1 + b[1].size() + 1 + 1, vector <char> (b[2].size(), ' '));


	

	res.back() = b[2];
	for (int i = 0; i < 2; ++i) {
		for (int j = 0; j < b[i].size(); ++j) {
			res[i][j] = b[i][j];
		}
	}

	for (int i = 0; i < max(b[0].size(), b[1].size()); ++i) {
		res[2][i] = '-';
	}

	for (int i = 0; i < b[2].size(); ++i) {
		res[res.size() - 2][i] = '-';
	}

	for (int i = 0; i < b[1].size(); ++i) {
		for (int j = 0; j < b[0].size(); ++j) {
			if (b[1][i] == '1')
				res[3 + i][i + j] = b[0][j];
			else 
				res[3 + i][i + j] = '0';
		}
	}


	for (int i = 0; i < res.size(); ++i) {
		for (int j = res[i].size() - 1; j >= 0; --j) {
			cout << res[i][j];
		}
		cout << "\n";
	}
	cout << "\n";
}