#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

int a[500][500];
int n, m;

const int INF = 1000000000;

void solve() {
	cin >> n >> m;
	//cerr << n << ' ' << m << endl;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++) {
			a[i][j] = INF;
			if (i == j)
				a[i][j] = 0;
		}
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		a[u][v] = a[v][u] = 1;
	}

	for (int k = 0; k < n; k++)
		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				a[i][j] = min(a[i][j], a[i][k] + a[k][j]);
	/*for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++)
			cerr << a[i][j] << ' ';
		cerr << endl;
	}*/
	int res = INF;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			for (int k = 0; k < n; k++) {
				if (i == j || i == k || j == k)
					continue;
				if (a[i][j] + a[j][k] != a[i][k]) {
					res = min(res, a[i][j] + a[j][k] + a[k][i]);
				}
			}
		}
	}
	cout << res << endl;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
		solve();
}