#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

const int MOD = 2017;

int dp[300];

int modpow(int a, int n) {
	if (n == 0)
		return 1;
	if (n % 2 == 1) 
		return modpow(a, n - 1) * a % MOD;
	else {
		int x = modpow(a, n / 2);
		return x * x % MOD;
	}
}

int rev(int a) {
	return modpow(a, MOD - 2);;
}

int c(int n, int k) {
	int res = 1;
	int fact = 1;
	for (int i = 0; i < k; i++) {
		res = res * (n - i) % MOD;
		fact = fact * (i + 1) % MOD;
	}
	res = res * rev(fact) % MOD;
	return res;
}

int fact(int n) {
	int res = 1;
	for (int i = 1; i <= n; i++)
		res = (res * i) % MOD;
	return res;
}

void solve() {
	int n, k;
	//cerr << modpow(3, 3) << endl;
	//cerr << rev(2) << endl;
	//cerr << c(3, 0) << endl;
	cin >> n >> k;
	dp[0] = 0;
	for (int i = 1; i <= k; i++) {
		int s1 = modpow(i, n);
		// cerr << s1 << endl;
		int s2 = 0;
		for (int j = 0; j < i; j++) {
			s2 = (s2 + dp[j] * c(i, j) % MOD * fact(j) % MOD) % MOD;
		}
		//cerr << s2 << endl;
		int f = fact(i);

		int res = (((s1 - s2) % MOD + MOD) % MOD) * rev(f) % MOD;
		dp[i] = res;
	}
	cout << dp[k] << endl;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
		solve();
}