#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>
#include <memory.h>

#define forn(i, n) for(int i = 0; i < (int)(n); ++i)
#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i) 
#define for1(i, n) for(int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

int f(string s)
{
	int r = 0;
	reverse(all(s));
	forn (i, s.length())
		r += (s[i] - '0') * (1 << i);
	return r;
}

int qBits(i64 x)
{
	int r = 0;
	while (x) {x >>= 1LL; r++;}
	return r;
}

void pr(int len, string s)
{
	forn (i, len - s.length())
		cout << " ";
	cout << s << "\n";
}

void solve(string s, string t) {
	i64 a = f(s), b = f(t);
	i64 r = a * b;
	int len = max(qBits(r), (int)s.length());
	len = max(len, (int) t.length());
	int q2 = t.length();
	pr(len, s);
	pr(len, t);
	pr(len, string(max(s.length(), t.length()), '-'));
	int w = 0;
	ford (i, q2)
	{
		string cur = s;
		if (t[i] == '0')
			cur = string(s.length(), '0');
		pr(len - w, cur);
		w++;
	}
	cout << string(len, '-') << "\n";
	string ans;
	while (r)
	{
		ans = string(1, '0' + (r & 1)) + ans;
		r >>= 1;
	}
	if (ans.empty()) ans = "0";
	pr(len, ans);
	cout << "\n";
}

int main() {
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int T;
	cin >> T;
	for1 (t1, T)
	{
		cout << "Test " << t1 << "\n";
		string s, t;
		cin >> s >> t;
		solve(s, t);
		if (t1 != T)
			cout << "\n";
	}
	return 0;
}
