#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>
#include <memory.h>
#include <unordered_map>

#define forn(i, n) for(int i = 0; i < (int)(n); ++i)
#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i) 
#define for1(i, n) for(int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

unordered_map<int, bool> M;
const int N = 1000000;
char arM[N];

bool solve(int n) {
	if( n < N ) {
		if( arM[n] != -1 ) return arM[n];
	} else {
		auto it = M.find(n);
		if( it != M.end() ) return it->second;
	}
	if( n == 1 ) return false;
	bool r = false;
	fore(j, 2, 9) {
		int nn = (n + j - 1) / j;
		if( !solve(nn) ) {
			r = true;
			break;
		}
	}
	if( n < N ) {
		return arM[n] = r;
	} else {
		return M[n] = r;
	}
}

int main() {
	forn(i, N) arM[i] = -1;
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int T = 2500;
	cin >> T;
	for1 (t1, T) {
		int n;
		n = 1 + rand() % 1000000000;
		cin >> n;
		bool r = solve(n);
		cout << 2 - (int)(r) << '\n';
	}
	return 0;
}
