#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <ctime>
#include <unordered_map>

using namespace std;

typedef long long ll;

inline ll tonum(const string& a){
	ll ans = 0;
	for (ll i = 0; i < a.size(); ++i){
		ans <<= 1;
		if (a[i] == '1') ans |= 1;
	}
	return ans;
}
inline ll mylen(ll num){
	if (num == 0) return 1;
	ll ans = 0;
	while (num > 0){
		++ans;
		num >>= 1;
	}
	return ans;
}

inline void prnt(ll cnt, char c){
	for (ll i = 0; i < cnt; ++i) cout << c;
}
inline vector<ll> tos(ll num){
	vector<ll> ans;
	if (num == 0){
		ans.push_back(0);
	} else {
		while (num) {
			ans.push_back(num & 1);
			num >>= 1;
		}
	}
	reverse(ans.begin(), ans.end());
	return ans;
}

inline void solve(){
	string a, b;
	cin >> a >> b;
	ll na = tonum(a);
	ll nb = tonum(b);
	ll nc = na * nb;
	ll len = mylen(nc);
	len = max(len, (ll)max(a.size(), b.size()));
	prnt(len - a.size(), ' '); cout << a << endl;
	prnt(len - b.size(), ' '); cout << b << endl;
	prnt(len - max(a.size(), b.size()), ' ');
	prnt(max(a.size(), b.size()), '-');
	cout << endl;
	ll rsp = 0;
	ll lsp = len - a.size();
	for (ll i = b.size() - 1; i >= 0; --i){
		prnt(lsp, ' ');
		if (b[i] == '1') cout << a;
		else prnt(a.size(), '0');
		prnt(rsp, ' ');
		--lsp; ++rsp;
		cout << endl;
	}
	prnt(len, '-');
	cout << endl;
	vector<ll> x = tos(nc);
	prnt(len - x.size(), ' ');
	for (ll i = 0; i < x.size(); ++i)
		cout << x[i];
	cout << endl;
}

int main(){
	ios_base::sync_with_stdio(false);
	ll ttt;
	cin >> ttt;
	for (ll i = 0; i < ttt; ++i){
		cout << "Test " << i + 1 << endl;
		solve();
		cout << endl;
	}
	return 0;
}