#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int INF = (int) 1e9;
const int N = 222;
const int M = 2222;
int n, t, u[M], v[M], tc, m, d[N][N];

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d", &tc);
	for (int it = 0; it < tc; ++it) {
		scanf("%d%d", &n, &m);
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < n; ++j)
				d[i][j] = (i == j) ? 0 : INF;
		for (int i = 0; i < m; ++i) {
			scanf("%d%d", &u[i], &v[i]), --u[i], --v[i];
			d[u[i]][v[i]] = d[v[i]][u[i]] = 1;
		}
		for (int k = 0; k < n; ++k)
			for (int i = 0; i < n; ++i)
				for (int j = 0; j < n; ++j)
					d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
		int res = INF;
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < m; ++j)
				if (d[i][u[j]] == d[i][v[j]])
					res = min(res, d[i][u[j]] + d[i][v[j]] + 1);
		for (int i = 0; i < m; ++i)
			for (int j = i + 1; j < m; ++j) {
				int mind = min(min(d[u[i]][u[j]], d[u[i]][v[j]]), min(d[v[i]][u[j]], d[v[i]][v[j]]));
				for (int t = 0; t < 2; ++t) {
					if ((d[u[i]][u[j]] == mind) && (d[v[i]][v[j]] == mind)) res = min(res, d[u[i]][u[j]] + d[v[i]][v[j]] + 2);
					swap(v[j], u[j]);
				}
			}
		printf("%d\n", res);
	}
	return 0;
}