#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

int used[256]; 

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	ios::sync_with_stdio(false); 

	int t = 0;
	cin >> t; 
	for (int tt = 0; tt < t; tt++) {
		cout << "Test " << tt + 1 << endl;
		string a, b; 
		cin >> a >> b; 
		int n = max(a.length(), b.length()); 
		
		string ina = a, inb = b; 

		vector <int> aa(2 * n + 5, 0); 
		for (int i = 0; i < a.length(); i++) 
		{
			int pp = a.length() - i - 1; 
			for (int j = 0; j < b.length(); j++) {
				int pp2 = b.length() - j - 1; 

				aa[pp + pp2] += min(a[i], b[j]) - '0'; 
			}
		}

		for (int i = 0; i < 2 * n + 4; i++) {
			int nxt = aa[i] / 2; 
			aa[i] %= 2; 
			aa[i + 1] += nxt; 
		}

		int ind = 1; 
		for (int i = 0; i < 2 * n + 5; i++) 
		{
			if (aa[i]) ind = i + 1; 
		}

		aa.resize(ind); 
		reverse(aa.begin(), aa.end());

		int k = max(n, int(aa.size())); 
		while (a.length() != k) a = ' ' + a; 
		while (b.length() != k) b = ' ' + b; 

		cout << a << "\n";
		cout << b << "\n"; 
		for (int t = 0; t < k - n; t++) {
			cout << " "; 
		}
		for (int i = 0; i < n; i++) {
			cout << "-"; 
		}
		cout << endl; 
		
		int pr = 0; 
		reverse(inb.begin(), inb.end()); 
		for (int i = 0; i < inb.length(); i++) {
			for (int j = 0; j < k - ina.size() - pr; j++) {
					cout << " "; 
				}
			if (inb[i] == '1') {
				cout << ina; 
			} else {
				for (int j = 0; j < ina.length(); j++) {
					cout << "0"; 
				}
			}
			for (int j = 0; j < pr; j++) {
				cout << " "; 
			}
			pr++; 
			cout << endl; 
		}
		for (int i = 0; i < k; i++) {
			cout << "-"; 
		}
		cout << endl;
		for (int i = 0; i < k - aa.size(); i++) {
			cout << " "; 
		}
		for (int i = 0; i < aa.size(); i++) {
			cout << aa[i]; 
		}
		cout << endl; 
		cout << endl; 
	}

	return 0;
}