#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 100500;
const int MOD = 1000000000;

int cntA[MAXN], cntM[MAXN];
int n, m;
int a[111], b[111];

void
process()
{
	scanf("%d%d", &n, &m);
	int k = 0;
	scanf("%d", &k);
	for (int i = 0; i < k; ++i) {
		scanf("%d", &a[i]);
	}
	sort(a, a + k);
	k = unique(a, a + k) - a;
	int s = 0;
	scanf("%d", &s);
	for (int i = 0; i < s; ++i) {
		scanf("%d", &b[i]);
	}
	sort(b, b + s);
	s = unique(b, b + s) - b;
	for (int i = n; i <= m; ++i) {
		cntA[i] = cntM[i] = 0;
	}
	cntA[n] = 1;
	for (int i = n; i < m; ++i) {
		int allCnt = (cntA[i] + cntM[i]) % MOD;
		if (allCnt) {
			for (int j = 0; j < k; ++j) {
				if (i + a[j] <= m) {
					cntA[i + a[j]] = (cntA[i + a[j]] + allCnt) % MOD;
				}
			}
			for (int j = 0; j < s; ++j) {
				if (i * b[j] <= m) {
					cntM[i * b[j]] = (cntM[i * b[j]] + allCnt) % MOD;
				}
			}
		}
	}
	printf("%d\n", cntM[m]);
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process();
	}
	return 0;
}