#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 100500;

ll tm[MAXN];
int n;
ll k;

ll
getCnt(ll x)
{
	ll res = 0ll;
	for (int i = 1; i <= n; ++i) {
		res += x / tm[i];
	}
	return res;
}

void
process()
{
	scanf("%d%lld", &n, &k);
	for (int i = 1; i <= n; ++i) {
		scanf("%lld", &tm[i]);
	}
	ll l = 0ll, r = tm[1] * k + 1;
	while (l < r - 1) {
		ll mid = (l + r) / 2;
		if (getCnt(mid) >= k) {
			r = mid;
		} else {
			l = mid;
		}
	}
	printf("%lld\n", r);
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process();
	}
	return 0;
}