#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

inline ll get(string s) {
	ll res = 0;
	for (int i = 0; i < sz(s); ++i) {
		res = res * 2 + s[i] - '0';
	}
	return res;
}

inline string write(ll val) {
	if (val == 0) {
		return "0";
	}
	string res = "";
	while (val > 0) {
		res.pb('0' + val % 2);
		val /= 2;
	}
	reverse(all(res));
	return res;
}

inline void solve() {
	string a, b;
	cin >> a >> b;
	vector<string> ans;
	ans.pb(a);
	ans.pb(b);
	string add = "";
	for (int i = 0; i < max(sz(a), sz(b)); ++i) {
		add.pb('-');
	}
	ans.pb(add);
	for (int i = sz(b) - 1; i >= 0; --i) {
		add = "";
		for (int j = 0; j < sz(a); ++j) {
			add.pb('0' + (a[j] - '0') * (b[i] - '0'));
		}
		for (int j = 0; j < sz(b) - 1 - i; ++j) {
			add.pb(' ');
		}
		ans.pb(add);
	}
	ll va = get(a), vb = get(b);
	add = write(va * vb);
	string add2 = "";
	for (int i = 0; i < sz(add); ++i) {
		add2.pb('-');
	}
	ans.pb(add2);
	ans.pb(add);
	int max_len = 0;
	for (int i = 0; i < sz(ans); ++i) {
		max_len = max(max_len, sz(ans[i]));
	}
	int cnt = 0;
	for (int i = 0; i < sz(ans); ++i) {
		cnt += (ans[i][0] == '-');
		for (int j = 0; j < max_len - sz(ans[i]); ++j) {
			printf("%c", ((cnt == 2 && ans[i][0] == '-') ? '-' : ' '));
		}
		int ptr = sz(ans[i]) - 1;
		while (ptr >= 0 && ans[i][ptr] == ' ') {
			--ptr;
		}
		for (int j = 0; j <= ptr; ++j) {
			printf("%c", ans[i][j]);
		}
		puts("");
	}
}

int main() {
#ifdef LOCAL42
#define TASK "B"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		if (i > 0) {
			puts("");
		}
		printf("Test %d\n", i + 1);
		solve();
	}
	return 0;
}
