#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

LL s2i(string s) {
  LL x = 0;
  for (auto c : s) {
    x = x * 2 + (c - '0');
  }
  return x;
}
int ilen(LL x) {
  int len = 0;
  while (x) len++, x /= 2;
  return max(len, 1);
}

void repeat(int n, char c) {
  FOR(i, 0, n) cout << c;
}

void test(int ti) {
  string a, b;
  cin >> a >> b;
  LL answer = s2i(a) * s2i(b);
  int len = ilen(answer);
  len = max(len, int(a.length() + b.length() - 1));
  cout << "Test " << ti << "\n";
  repeat(len - a.length(), ' '); cout << a << "\n";
  repeat(len - b.length(), ' '); cout << b << "\n";
  int dashes = max(a.length(), b.length());
  repeat(len - dashes, ' '); repeat(dashes, '-'); cout << "\n";
  ROF(i, 0, b.length()) {
    repeat(len - a.length() - (b.length() - i - 1), ' ');
    if (b[i] == '0') {
      repeat(a.length(), '0');
    } else {
      cout << a;
    }
    cout << "\n";
  }
  repeat(len, '-'); cout << "\n";
  string out;
  while (answer) {
    out = char('0' + (answer & 1)) + out;
    answer /= 2;
  }
  if (out.length() == 0) out = "0";
  repeat(len - out.length(), ' ');
  cout << out << "\n";
}

int main() {
  int T;
  cin >> T;
  FOR(i, 0, T) {
    if (i) cout << "\n";
    test(i + 1);
  }
  return 0;
}
