#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

int dp[131072];
const int MOD = 1000000000;

void test() {
  vector<int> a, b;
  int K, S, t;
  int N, M;
  cin >> N >> M;
  cin >> K; FOR(i, 0, K) (cin >> t), a.push_back(t);
  cin >> S; FOR(i, 0, S) (cin >> t), b.push_back(t);
  sort(a.begin(), a.end());
  sort(b.begin(), b.end());
  K = unique(a.begin(), a.end()) - a.begin();
  S = unique(b.begin(), b.end()) - b.begin();
  dp[M] = 1;
  ROF(i, 1, M) {
    dp[i] = 0;
    FOR(j, 0, K) if (i + a[j] < M) dp[i] = (dp[i] + dp[i + a[j]]) % MOD;
    FOR(j, 0, S) if (i * b[j] <= M) dp[i] = (dp[i] + dp[i * b[j]]) % MOD;
//    cout << i << ":" << dp[i] << endl;
  }
  cout << dp[N] << endl;
}

int main() {
  int T;
  cin >> T;
  FOR(i, 0, T) test();
  return 0;
}
