#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

int n, k;
vector <unsigned long long> arr;

bool check(unsigned long long t) {
  unsigned long long count = 0;
  for (auto const &i : arr) {
     count += t / i;
  }

  return count >= k;
}

int main() {
  ios_base::sync_with_stdio(false);
  int T;
  cin >> T;

  FOR(_t, 0, T) {
    cin >> n >> k;
    arr.resize(n);
    for (auto &i : arr) {
      cin >> i;
    }

    unsigned long long left = 0, right = 1000000LL * 1000000LL * 1000000LL + 100LL;

    while (left + 1 != right) {
      unsigned long long middle = (left + right) / 2;
      (check(middle) ? right : left) = middle;
    }

    cout << right << '\n';
  }

  return 0;
}
