#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

const int MOD = 2017;

LL pmod(LL x, LL p) {
  LL b = 1;
  while (p) {
    if (p & 1) b = b * x % MOD;
    x = x * x % MOD;
    p /= 2;
  }
  return b;
}
LL inv(LL x) {
  return pmod(x, MOD - 2);
}

LL cnk(int n, int k) {
  LL ans = 1;
  FOR(i, 0, k) ans = ans * (n - i) % MOD;
  FOR(i, 1, k + 1) ans = ans * inv(i) % MOD;
  return ans;
}
LL fact(int K) {
  LL ans = 1;
  FOR(i, 2, K + 1) ans = ans * i % MOD;
  return ans;
}

int main() {
  int T;
  cin >> T;
  FOR(i, 0, T) {
    int N, K;
    cin >> N >> K;
    LL ans = 0;
    int sgn = 1;
    ROF(k, 1, K + 1) {
      LL cur = pmod(k, N);
      cur = cur * cnk(K, k);
      ans = (ans + sgn * cur + MOD) % MOD;
      sgn = sgn * -1;
    }
    cout << (ans * inv(fact(K))) % MOD << "\n";
  }
  return 0;
}
