#include <iostream>
#include <fstream>
#include <ctime>
#include <cstdio>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <bitset>
#include <deque>
#include <stack>
#include <queue>
using namespace std;

#define fs first
#define sc second

#define pb push_back
#define mp make_pair

#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define all(x) (x).begin(), (x).end()

const int MAXN = 205;
char used[MAXN];
int d[MAXN], p[MAXN], n;
vector<int> g[MAXN];

int bfs(int s) {
    for(int i = 0; i < n; i++)
        used[i] = false;
    queue<int> q;
    for(int i = 0; i < n; i++)
        d[i] = MAXN;
    d[s] = 0;
    p[s] = -1;
    q.push(s);
    used[s] = true;
    int ans = MAXN;
    while(!q.empty()) {
        int v = q.front();
        q.pop();
        for(size_t i = 0; i < g[v].size(); i++)
            if(!used[g[v][i]]) {
                d[g[v][i]] = d[v] + 1;
                p[g[v][i]] = v;
                q.push(g[v][i]);
                used[g[v][i]] = true;
            }
            else if(g[v][i] != p[v])
                ans = min(ans, d[v] + d[g[v][i]] + 1);
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        int m;
        cin >> n >> m;
        for(int i = 0; i < n; i++)
            g[i].clear();
        for(int i = 0; i < m; i++) {
            int v, u;
            cin >> v >> u;
            v--;
            u--;
            g[v].push_back(u);
            g[u].push_back(v);
        }
        int ans = MAXN;
        for(int i = 0; i < n; i++)
            ans = min(ans, bfs(i));
        cout << ans << '\n';
    }
    return 0;
}
