#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <list>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef pair<int, int> ii;
typedef pair<int, ii> iii;

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int T;
	cin >> T;
	for (int q = 0; q < T; q++)
	{
		printf("Test %d\n", q + 1);
		string a, b;
		cin >> a >> b;
		ll i_a = 0, i_b = 0, p = 1;
		for (int i = a.size() - 1; i >= 0; i--)
		{
			i_a += (a[i] - '0') * p;
			p *= 2;
		}
		p = 1;
		for (int i = b.size() - 1; i >= 0; i--)
		{
			i_b += (b[i] - '0') * p;
			p *= 2;
		}

		ll i_ans = i_a * i_b;
		string ans = "";
		while (i_ans > 0)
		{
			if (i_ans & 1)
			{
				ans.push_back('1');
			}
			else
			{
				ans.push_back('0');
			}
			i_ans /= 2;
		}
		reverse(ans.begin(), ans.end());

		int sz = max(a.size(), b.size());
		bool nulans = false;
		if (ans == "")
		{
			for (int i = 0; i < sz; i++)
				ans.push_back('0');	
			nulans = true;
		}

		int spaces = 0;

		spaces = ans.size() - a.size();
		for (int i = 0; i < spaces; i++)
			printf(" ");
		printf("%s\n", a.c_str());
		
		spaces = ans.size() - b.size();
		for (int i = 0; i < spaces; i++)
			printf(" ");
		printf("%s\n", b.c_str());

		for (int i = 0; i < ans.size() - sz; i++)
		{
			printf(" ");
		}
		for (int i = 0; i < sz; i++)
			printf("-");
		printf("\n");
		
		spaces = ans.size();
		for (int j = b.size()-1; j >= 0; j--)
		{
			string s;
			for (int i = 0; i < a.size(); i++)
			{
				if (b[j] == '1' && a[i] == '1')
					s.push_back('1');
				else
					s.push_back('0');
			}
			for (int i = 0; i < spaces - s.size(); i++)
				printf(" ");
			printf("%s\n", s.c_str());
			spaces--;
		}

		for (int i = 0; i < ans.size(); i++)
			printf("-");
		if (!nulans)
			printf("\n%s\n\n", ans.c_str());
		if (nulans)
		{
			printf("\n");
			for (int i = 0; i < ans.size() - 1; i++)
				printf(" ");
			printf("0\n\n");
		}
	}

	return 0;
}