#include <iostream>
#include <cstdio>

using namespace std;

const int N = 100005;
int T[N + 1];

void change(int i, int x) {
	++i;
	while(i <= N) {
		T[i] += x;
		i += (i & -i);
	}
}

int sum(int i) {
	int ret = 0;
	while(i != 0) {
		ret += T[i];
		i -= (i & -i);
	}
	return ret;
}

int A[N];

int main() {
	cin.sync_with_stdio(false);
	
	int Te;
	cin >> Te;
	
	while(Te--) {
		int n;
		cin >> n;
		fill(T, T + N + 1, 0);
		for(int i = 0; i < n; ++i) {
			
			int x;
			cin >> x;
			--x;
			A[i] = x;
		}
		for(int i = n - 1; i >= 0; --i) {
			int x = A[i];
			change(x, 1);
			A[i] = sum(x);
		}
		for(int i = 0; i < n; ++i) {
			if(i != 0) cout << ' ';
			cout << A[i];
		}
		cout << '\n';
	}
	
	return 0;
}
