#include <iostream>
#include <cstdio>
#include <climits>
#include <queue>

using namespace std;

typedef long long int Z;

Z T[100000];

int main() {
	cin.sync_with_stdio(false);
	
	Z Te;
	cin >> Te;
		
	while(Te--) {
		Z N, K;
		cin >> N >> K;
		
		for(Z i = 0; i < N; ++i) {
			cin >> T[i];
		}
		
		Z a = 1;
		Z b = 1000000000000000000LL;
		while(a != b) {
			Z m = a + (b - a) / 2;
			
			Z count = 0;
			for(Z i = 0; i < N && count < K; ++i) {
				count += m / T[i];
			}
			if(count >= K) {
				 b = m;
			} else {
				 a = m + 1;
			}
		}
		
		cout << a << "\n";
	}
	
	return 0;
}
