#include <iostream>
#include <cstdio>
#include <climits>
#include <queue>
#include <algorithm>

using namespace std;

typedef long long int Z;

Z F[100];

int main() {
	cin.sync_with_stdio(false);
	
	F[1] = 1;
	Z N;
	for(N = 2; F[N - 1] <= 1000000000; ++N) {
		F[N] = F[N - 1] + F[N - 2];
	}
	
	Z Te;
	cin >> Te;
		
	while(Te--) {
		Z n;
		cin >> n;
		
		pair<Z, Z> best(LLONG_MAX, LLONG_MAX);
		
		for(Z k = 1; 2 * k + 1 < N; ++k) {
			if(2 * k + 2 < N) {
				Z a = F[2 * k] * n / F[2 * k + 1];
				Z b = F[2 * k + 1] * n / F[2 * k + 2];
				if(a < b) {
					Z c = b;
					Z A = F[2 * k + 1] * c - F[2 * k] * n;
					Z B = F[2 * k - 1] * n - F[2 * k] * c;
					best = min(best, make_pair(B, A));
				}
			}
			
			{
				Z a = (F[2 * k] * n + F[2 * k + 1] - 1) / F[2 * k + 1];
				Z b = (F[2 * k - 1] * n + F[2 * k] - 1) / F[2 * k];
				if(a < b) {
					Z c = a;
					Z A = F[2 * k - 1] * n - F[2 * k] * c;
					Z B = F[2 * k - 1] * c - F[2 * k - 2] * n;
					best = min(best, make_pair(B, A));
				}
			}
		}
		
		cout << best.second << " " << best.first << "\n";
	}
	
	return 0;
}
