#include <iostream>
#include <fstream>
#include <vector>
#include <cassert>
#include <algorithm>
using namespace std;
typedef vector<int> VI;
int n, m, d[210], res, oo = 1000000000;
vector<VI> a;

void addEdge(int v, int u) {
	a[v].push_back(u);
	a[u].push_back(v);
}

void bfs(int v, int prev) {
	if (d[v] >= res - 1) return;

	for (int i = 0; i < a[v].size(); i++) {
		int u = a[v][i];

		if (u != prev) {
			if (d[u] < oo) res = min(res, d[v] + d[u] + 1);
			else {
				d[u] = d[v] + 1;
				bfs(u, v);
			}
		}
	}
}

int main()
{
	ifstream inFile;
	ofstream outFile;


	int tests, v, u, i, j;
	inFile >> tests;

	while (tests > 0) {

		inFile >> n >> m;

		a.assign(n, std::vector<int>());

		for (int i = 0; i < m; i++) {
			inFile >> v >> u;

			addEdge(v - 1, u - 1);
		}

		res = oo;
		for (v = 0; v < n; v++) {
			for (int j = 0; j < n; j++) d[j] = oo;
			d[v] = 0;

			bfs(v, -1);
		}
		
		outFile << res << endl;

		tests--;
	}
	

	inFile.close();
	outFile.close();

	return 0;
}