#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>
#include <queue>
#include <map>
#include <set>

#ifdef WIN32
    #define I64 "%I64d"
#else
    #define I64 "%lld"
#endif // WIN32

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 2002
#define md 1000000007
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define EPS 0.00000001
#define ll long long
#define ull unsigned long long

using namespace std;
const int maxn = 103;
ll a[maxn], n, t, sum, ans;


int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG
    cin >> t;

    while (t--)
    {
        cin >> n;
        sum = 0;
        ans = 0;
        for (int i = 0; i < n; i++)
        {
            cin >> a[i];
            sum += a[i];
        }

        while (sum > 0)
        {
            for (int i = 0; i < n; i++)
            {
                if (a[i] % 10 != 0)
                {
                    sum -= a[i] % 10;
                    a[i] -= a[i] % 10;
                    ans++;
                }
            }

            if (sum)
            {
                for (int i = 0; i < n; i++)
                {
                    if (a[i])
                    {
                        a[i] /= 10;
                        sum -= a[i] * 10 - a[i];
                    }
                }
                ans++;
            }
        }

        cout << ans << endl;
    }

    return 0;
}
