#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const int maxn = 100010;
int n; 
int t[maxn];

void inc(int r, int val) {
	for (;r <= n ; r |= r+1) t[r] += val;
}

int sum(int r) {
	int res = 0;
	for (;r>=0; r=(r&(r+1))-1) res += t[r];
	return res;
}


void solve() {
	scanf("%d", &n);
	forn(i, n+1) t[i] = 0;
	vector<int> a(n);
	forn(i, n) scanf("%d", &a[i]);
	vector<int> res(n);
	for (int i = n-1; i >= 0; --i) {
		int cur = a[i];
		res[i] = sum(cur-1);
		inc(cur, 1);
	}
	forn(i, n) printf("%d ", res[i]);
	printf("\n");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int T; scanf("%d", &T); while (T--) solve();
	return 0;
}
