#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

const int maxn =  (int)1e5 + 10;

int t[maxn];

void solve() {
	int n,k; cin >> n >> k;
	for (int i = 0; i < n; i++) {
		scanf("%d",&t[i]);
	}
	ll l = 0;
	ll r = (ll)1e18;
	while(l < r - 1) {
		ll m = (l + r) >> 1;
		ll cur = 0;
		for (int i = 0; i < n; i++) {
			cur += m / t[i];
			if (cur >= k) break;
		}
		if (cur >= k) {
			r = m;
		} else {
			l = m;
		}
	}
	cout << r << endl;
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	int T; cin >> T;

	while(T--) solve();

	return 0;
}
