#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

const int mod = 2017;

int dp[22],c[22][22];

int binpow(int a, int b) {
	int res = 1;
	while(b > 0) {
		if (b & 1) res = res * a % mod;
		a = a * a % mod;
		b >>= 1;
	}
	return res;
}

void solve() {
	int n,k; cin >> n >> k;
	dp[1] = 1;
	for (int i = 2; i <= k; i++) {
		dp[i] = binpow(i,n);
		for (int j = 1; j < i; j++) {
			dp[i] -= dp[j] * c[i][j] % mod;
			if (dp[i] < 0) dp[i] += mod;
		}
	}
	int res = dp[k];
	for (int i = 2; i <= k; i++) {
		res = res * binpow(i,mod - 2) % mod;
	}
	cout << res << endl;
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	for (int i = 0; i < 22; i++) {
		c[i][0] = 1;
	}
	for (int i = 1; i < 22; i++) {
		for (int j = 1; j <= i; j++) {
			c[i][j] = c[i - 1][j] + c[i - 1][j - 1];
			c[i][j] %= mod;
		}
	}

	int T; cin >> T;

	while(T--) solve();

	return 0;
}

	