from math import factorial

def power(a, x, m):
    if x == 0:
        return 1
    b = power(a, x // 2, m)
    b = b * b % m
    if x % 2 == 1:
        b = b * a % m
    return b
    
def C(n, k, mod):
    x = 1
    for i in range(k):
        x *= (n - i)
    for i in range(1, k + 1):
        x //= i
    return x % mod
    
def f(n, k):
    mod = 2017
    ans = 0
    for j in range(k):
        ans += power(k - j, n, mod) * C(k, j, mod) * ((-1) ** j) % mod
    ans = ans * power(factorial(k), mod - 2, mod) % mod
    if ans < 0:
        ans += mod
    return ans

t = int(input())
for i in range(t):
    n, k = map(int, input().strip().split())
    print(f(n, k))
