import java.util.Scanner;

public class Main {
    
    static boolean check(long[] seq, long k, long time) {
        long details = 0;
        for (int i=0;i<k;++i) {
            details += (time / seq[i]); 
                if (details >= k) return true;
        }
        return false;
    }
    
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        long t = in.nextLong();
        for (long test=0; test<t; ++test) {
            int n = in.nextInt();
            long k = in.nextLong();
            long[] seq = new long[n];
            for (int i=0;i<n;++i) {
                seq[i] = in.nextLong();
            }
            //Arrays.sort(seq);
            
            long timeMin = 0;
            long timeMax = Long.MAX_VALUE;
            
            while (true) {
                long time = (timeMin + timeMax) / 2;
                boolean ctime = check(seq, k, time);
                boolean ctimeminus1 = check(seq, k, time-1);
                //System.out.println(time+" "+ctime+" "+ctimeplus1);
                if (ctime && !ctimeminus1) {
                    System.out.println(time);
                    break;
                } else if (ctime) {
                    timeMax = time-1;
                } else {
                    timeMin = time+1;
                }
            }
        }
    }
}