#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int n, m;
vector <vector <int> > g;
vector <int> depth;
int ans = -1;

void dfs(int v, int p = -1) {
	if (p == -1) {
		depth[v] = 0;
	}
	else {
		depth[v] = depth[p] + 1;
	}

	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];
		if (to == p) {
			continue;
		}
		if (depth[to] != -1) {
			if (depth[to] > depth[v])
				continue;
			if (ans == -1 || ans > depth[v] - depth[to] + 1) {
				ans = depth[v] - depth[to] + 1;
			}
		}
		else {
			dfs(to, v);
		}
	}
}

void solve() {
	cin >> n >> m;
	g.assign(n, vector <int>());
	depth.assign(n, -1);
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		--x;
		--y;
		g[x].push_back(y);
		g[y].push_back(x);
	}

	ans = -1;

	for (int i = 0; i < n; ++i) {
		if (depth[i] == -1) {
			dfs(i);
		}
	}

	cout << ans << "\n";
}