#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>
#include <vector>
#include <algorithm>
#include <ctime>
#include <unordered_map>
#include <queue>
#include <stack>
using namespace std;

typedef long long ll;

const int N = 300;
bool used[N];
vector<int> g[N];
int p[N];

int h[N];
int ans;
inline void dfs(int v, int p = -1, int ch = 0){
	h[v] = ch;
	used[v] = true;
	for (int i = 0; i < g[v].size(); ++i){
		int u = g[v][i];
		if (u == p) continue;
		if (!used[u]) dfs(u, v, ch + 1);
		else {
			int d = abs(ch - h[u]) + 1;
			ans = min(ans, d);
		}
	}
}

inline void solve(){
	int n, m;
	cin >> n >> m;
	fill(used, used + n, false);
	fill(p, p+ n, -1);
	for (int i = 0; i < n; ++i)
		g[i].resize(0);
	for (int i = 0; i < m; ++i){
		int a, b;
		cin >> a >> b;
		--a; --b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	ans = 1e9;
	for (int i = 0; i < n; ++i) if (!used[i]){
		/*stack<int> q;
		q.push(i);
		used[i] = true;
		while (!q.empty()){
			int v = q.top(); q.pop();
			for (int j = 0; j < g[v].size(); ++j){
				int u = g[v][j];
				if (u == p[v]) continue;
				if (!used[u]){
					p[u] = v;
					used[u] = true;
					q.push(u);
				} else {
					int cans = 1;
					for (int tv = v; tv != u; tv = p[tv])
						++cans;
					ans = min(ans, cans);
				}
			}
		}*/
		dfs(i);
	}
	cout << ans << endl;
}

int main(){
	ios_base::sync_with_stdio(false);
	int ttt;
	cin >> ttt;
	for (int i = 0; i < ttt; ++i){
		solve();
	}
	return 0;
}