#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 2000*100 + 10;
const dbl eps = 1e-9;
const int mod = 2017;

bool cnt[11];

int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	
	int n;
	scanf("%d", &n);
	getchar();
	for (int i = 0; i < n; i++) {
		string s;
		getline(cin, s);
		for (int j = 0; j < 10; j++) cnt[j] = false;
		for (int j = 0; j < sz(s); j++)
			cnt[s[j] - '0'] = true;
		int pp = 0;
		for (int j = 0; j < 10; j++)
			pp += cnt[j];
		if (pp == 10) puts("allo");
		else {
			for (int j = 0; j < 10; j++) {
				if (!cnt[j])
					printf("%d", j);
			}
			puts("");
		}
	}

	return 0;
}