#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

int len(int x) {
    int cnt = 0;
    while (x) {
        cnt++;
        x /= 10;
    }
    return cnt;
}
int c(int x) {
    int cnt = 0;
    while (x) {
        if (x % 10 != 0) {
            cnt++;
        }
        x /= 10;
    }
    return cnt;
}

int main() {

    int ts;
    scanf("%d\n", &ts);

    for (int t = 0; t < ts; t++) {
        int n;
        scanf("%d\n", &n);
        int mx = 0;
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            int x;
            scanf("%d", &x);
            if (x == 0) continue;
            mx = max(mx, len(x));
            cnt += c(x);
        }

        cout << max(cnt + mx - 1, 0) <<  endl;
    }

    return 0;
}
