#include <iostream>
#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>
#include <memory.h>
#include <string>

using namespace std;

const int maxn = 128;
const int maxm = 16;

int len;

void print(string s) {
	while (s.length() < len) s = " " + s;
	cout << s << endl;
}

int main() {
	freopen("input.txt", "r", stdin);

	int T;
	cin >> T;
	for (int test = 1; test <= T; test++) {
		if (test > 1) cout << endl;
		cout << "Test " << test << endl;
		string s1, s2;
		cin >> s1 >> s2;
		string s3;
		for (int i = 0; i < (int)s1.length() + (int)s2.length() + 1; i++) s3 += '0';
		
		reverse(s1.begin(), s1.end());
		reverse(s2.begin(), s2.end());

		s1 += "0";
		for (int j = 0; j < (int)s2.length(); j++) if (s2[j] != '0') {
			int cur = 0;
			for (int i = 0; i < (int)s1.length(); i++) {
				int ncur = ((s3[j + i] - '0') + (s1[i] - '0') + cur) / 2;
				s3[j + i] = (((s3[j + i] - '0') + (s1[i] - '0') + cur) % 2) + '0';
				cur = ncur;
			}
		}
		//if (s3[(int)s3.length() - 1] == '0') s3.resize((int)s3.length() - 1);
		while ((int)s3.length() > 1 && s3[(int)s3.length() - 1] == '0') s3 = s3.substr(0, (int)s3.length() - 1);

		s1 = s1.substr(0, (int)s1.length() - 1);

		len = max(s3.length(), max(s1.length(), s2.length()));
		reverse(s1.begin(), s1.end());
		reverse(s2.begin(), s2.end());
		print(s1);
		print(s2);
		reverse(s2.begin(), s2.end());

		string ss = "";
		for (int i = 0; i < max(s1.length(), s2.length()); i++) ss += '-';
		print(ss);
		for (int i = 0; i < (int)s2.length(); i++) {
			string cur = "";
			if (s2[i] == '0') {
				for (int i = 0; i < (int)s1.length(); i++) cur += "0";
			} else {
				cur = s1;
			}
			for (int j = 0; j < i; j++) cur = cur + " ";
			print(cur);
		}
		ss = "";
		for (int i = 0; i < len; i++) ss += "-";
		print(ss);
		reverse(s3.begin(), s3.end());
		print(s3);
	}

	return 0;
}