#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back 

using namespace std;

const int N = 11;
const int INF = 1e9;
const int r[2][2] = {{2, 3}, {3, 2}};

bool use[N][N];
int n, m;
int mx, cnt;
bool oldVersion[N][N][5][5];

pair < int, int > next(int x, int y) {
	y = (y + 1);
	if (y == m) {
		y = 0;
		x++;
	}
	return mp(x, y);
}

bool check(int x, int y) {
	return 0 <= x && x < n && 0 <= y && y < m;
}

int ttt;


void rec(pair < int, int > pr) {
	ttt++;
	int x = pr.fr;
	int y = pr.sc;
	mx = max(mx, cnt);
	if (x == n) {
		return;
	}
	rec(next(x, y));
	if (use[x][y]) {
		return;
	}
	for (int t = 0; t < 2; t++) {
		bool flag = 1;
		for (int i = 0; i < r[t][0]; i++)
			for (int j = 0; j < r[t][1]; j++) {
				int x1 = x + i;
				int y1 = y + j;
				flag &= check(x1, y1) && !use[x1][y1];
			}
		//bool oldVersion[3][3];
		if (flag) {
			for (int i = -1; i < r[t][0] + 1; i++)
				for (int j = -1; j < r[t][1] + 1; j++) {
					int x1 = x + i;
					int y1 = y + j;
					if (check(x1, y1)) {
						oldVersion[x][y][i + 1][j + 1] = use[x1][y1];
					}
				}
			for (int i = -1; i < r[t][0] + 1; i++)
				for (int j = -1; j < r[t][1] + 1; j++) {
					int x1 = x + i;
					int y1 = y + j;
					if (check(x1, y1)) {
						use[x1][y1] = 1;
					}
				}
			cnt++;
			rec(next(x, y));
			for (int i = -1; i < r[t][0] + 1; i++)
				for (int j = -1; j < r[t][1] + 1; j++) {
					int x1 = x + i;
					int y1 = y + j;
					if (check(x1, y1)) 
						use[x1][y1] = oldVersion[x][y][i + 1][j + 1];

				}
			cnt--;
		}
	}

}


int main() {
#ifdef DEBUG
	freopen("in", "r", stdin);
#endif
	int T;
	scanf("%d", &T);
	for (int tt = 0; tt < T; tt++) {
		int k;
		scanf("%d%d%d", &n, &m, &k);
		memset(use, 0, sizeof(use));
		for (int i = 0; i < n; i++)
			use[i][0] = use[i][m - 1] = 1;
		for (int j = 0; j < m; j++)
			use[0][j] = use[n - 1][j] = 1;
		for (int d = 0; d < k; d++) {
			int x, y, w, h;
			scanf("%d%d%d%d", &x, &y, &w, &h);
			for (int i = -1; i < w + 1; i++)
				for (int j = -1; j < h + 1; j++) {
					int x1 = x + i;
					int y1 = y + j;
					if (check(x1, y1)) {
						use[x1][y1] = 1;
					}
				}
		}
		//for (int i = 0; i < n; i++, cerr << endl)
			//for (int j = 0; j < m; j++)
				//cerr << use[i][j];
		mx = 0;
		assert(cnt == 0);
		ttt = 0;
		rec(mp(0, 0));
		printf("%d\n", mx);
		//cerr << "ttt: " << ttt << endl;
	}
	

	return 0;
}

