#if 1
#include <cstdio>
#include <string>
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long li;
li frombin(string &s)
{
	li bit = 1, result = 0;
	for (li i = s.size() - 1; i >= 0; --i)
	{
		if(s[i] == '1') result += bit;
		bit <<= 1;
	}
	return result;
}
string tobin(li v)
{
	string result;
	while(v)
	{
		result += (v & 1) ? '1' : '0';
		v >>= 1;
	}
	reverse(result.begin(), result.end());
	if(result.size() == 0) result += '0';
	return result;
}
int main()
{
	cin.sync_with_stdio(false);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int T; cin >> T;
	for (int i = 0; i < T; ++i)
	{
		string s1, s2; cin >> s1 >> s2;
		li a = frombin(s1), b = frombin(s2);
		string s3 = tobin(a * b);
		int len2 = s1.size() + s2.size(); len2--;
		len2 = max(len2, (int)s3.size());
		int len1 = max(s1.size(), s2.size());


		vector<string> vs(s2.size());
		for (int i = s2.size() - 1; i >= 0; --i)
		{
			string str;
			if(s2[i] == '0')
			{
				str = string(s1.size(), '0');
			}
			else
			{
				str = s1;
			}
			for (int j = 0; j < i; ++j) str += ' ';
			while(str.size() < len2) str = " " + str;
			vs[i] = str;
		}

		while(s1.size() < len2) s1 = " " + s1;
		while(s2.size() < len2) s2 = " " + s2;
		while(s3.size() < len2) s3 = " " + s3;

		cout << "Test " << i + 1 << endl;
		cout << s1 << endl;
		cout << s2 << endl;
		string div1(len1, '-'); while(div1.size() < len2) div1 = " " + div1;
		cout << div1 << endl;
		for (int i = 0; i < vs.size(); ++i) cout << vs[i] << endl;
		cout << string(len2, '-') << endl;
		cout << s3 << endl;
		cout << endl;
	}
	return 0;
}
#endif